﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.application;
using ModbusDemo.MessageFormat;
namespace ModbusDemo.application
{
#if  DEBUG_TEST
   public class ControlMap
    {
       public delegate  bool bDelege_Handle(bool[] bControlData);
       public static bDelege_Handle bDelege_Operation;
       public static byte           byMapIdleID;    
       public static bool[]         byMapIdleControlData;
       public static string[]       strMapIdleChannelName;
       public static bool bMap_Idle_Open_Control(bool[] bControldata)
       {
            bool[] bControlBit = new bool[bControldata.Count()];
            bool bStatus;
            bool bHadOperation;
            for (int i = 0; i < bControldata.Count(); i++)
            {
                string str = "d" + i.ToString();
                for (int j = 0; j < strMapIdleChannelName.Count(); j++)
                {
                    if (str == strMapIdleChannelName[j])
                    {
                        bControlBit[i]  = true;
                        bControldata[i] = byMapIdleControlData[i];
                    }
                }
            }
            bStatus = ModualControl.bOperation_Machine(true, byMapIdleID, bControldata, bControlBit,out bHadOperation, 0, null);
            return bStatus;
       }
        public static bool bMap_Idle_Close_Control(bool[] bControldata)
        {
            bool[] bControlBit = new bool[bControldata.Count()];
            bool bStatus;
            bool bHadOperation;
            for (int i = 0; i < bControldata.Count(); i++)
            {
                string str = "d" + i.ToString();
                for (int j = 0; j < strMapIdleChannelName.Count(); j++)
                {
                    if (str == strMapIdleChannelName[j])
                    {
                        bControlBit[i] =  true;
                        bControldata[i] = byMapIdleControlData[i];
                    }
                }
            }
            bStatus = ModualControl.bOperation_Machine(true, byMapIdleID, bControldata, bControlBit,out bHadOperation, 0, null);
            return bStatus;
        }
        public static bool bControl_Map(bool bOpen, byte byControlID,bool[] bControlData, params string[] strOperationChannelName)
        {
            bool bMapStatus = true;
            if (bOpen == true)
            {
                if (byControlID == 31 && strOperationChannelName[0] == "d1")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cSouthWater.bOpen_Machine;
                }
                else if (byControlID == 16 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cNorthWater.bOpen_Machine;
                }
                else if (byControlID == 16 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cPumb1.bOpen_Machine;
                }
                else if (byControlID == 35 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cPumb2.bOpen_Machine;
                }
                else if (byControlID == 35 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer1.bOpen_Machine;
                }
                else if (byControlID == 39 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer2.bOpen_Machine;
                }
                else if (byControlID == 39 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer3.bOpen_Machine;
                }
                else
                { 
                    byMapIdleID              = byControlID;
                    strMapIdleChannelName    = strOperationChannelName;
                    byMapIdleControlData     = bControlData;
                    bDelege_Operation        = bMap_Idle_Open_Control;
                }
            }
            else
            {
                if (byControlID == 31 && strOperationChannelName[0] == "d1")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cSouthWater.bClose_Machine;
                }
                else if (byControlID == 16 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cNorthWater.bClose_Machine;
                }
                else if (byControlID == 16 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cPumb1.bClose_Machine;
                }
                else if (byControlID == 35 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cPumb2.bClose_Machine;
                }
                else if (byControlID == 35 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer1.bClose_Machine;
                }
                else if (byControlID == 39 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer2.bClose_Machine;
                }
                else if (byControlID == 39 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cStirrer3.bClose_Machine;
                }
                else
                {
                    byMapIdleID             = byControlID;
                    strMapIdleChannelName   = strOperationChannelName;
                    byMapIdleControlData    = bControlData;
                    bDelege_Operation       = bMap_Idle_Close_Control;
                }
            }
            return bMapStatus;
        }
    }
#else
   public class ControlMap
    {
       public delegate  bool bDelege_Handle(bool[] bControlData);
       public static bDelege_Handle bDelege_Operation;
       public static byte           byMapIdleID;    
       public static bool[]         byMapIdleControlData;
       public static string[]       strMapIdleChannelName;
       public static bool bMap_Idle_Open_Control(bool[] bControldata)
       {
            bool[] bControlBit = new bool[bControldata.Count()];
            bool bStatus;
            bool bHadOperation;
            for (int i = 0; i < bControldata.Count(); i++)
            {
                string str = "d" + i.ToString();
                for (int j = 0; j < strMapIdleChannelName.Count(); j++)
                {
                    if (str == strMapIdleChannelName[j])
                    {
                        bControlBit[i]  = true;
                        bControldata[i] = byMapIdleControlData[i];
                    }
                }
            }
            bStatus = ModualControl.bOperation_Machine(true, byMapIdleID, bControldata, bControlBit,out bHadOperation, 0, null);
            return bStatus;
       }
        public static bool bMap_Idle_Close_Control(bool[] bControldata)
        {
            bool[] bControlBit = new bool[bControldata.Count()];
            bool bStatus;
            bool bHadOperation;
            for (int i = 0; i < bControldata.Count(); i++)
            {
                string str = "d" + i.ToString();
                for (int j = 0; j < strMapIdleChannelName.Count(); j++)
                {
                    if (str == strMapIdleChannelName[j])
                    {
                        bControlBit[i] =  true;
                        bControldata[i] = byMapIdleControlData[i];
                    }
                }
            }
            bStatus = ModualControl.bOperation_Machine(true, byMapIdleID, bControldata, bControlBit,out bHadOperation, 0, null);
            return bStatus;
        }
        public static bool bControl_Map(bool bOpen, byte byControlID,bool[] bControlData, params string[] strOperationChannelName)
        {
            bool bMapStatus = true;
            if (bOpen == true)
            {
                #region  东中转池开映射
                if (byControlID == 4 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cSouthWater.bOpen_Machine;
                }
                else if (byControlID == 4 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cNorthWater.bOpen_Machine;
                }
                #endregion 
                #region 西中转池开映射
                else if (byControlID == 49 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cWestTransitPool.cSouthWater.bOpen_Machine;
                }
                else if (byControlID == 49 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cWestTransitPool.cNorthWater.bOpen_Machine;
                }
                #endregion
                #region 中控柜开映射和暂停映射
                else if (byControlID == 47 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cCentralControlRoom.cStartButton1.bOpreation_Button;
                }
                else if (byControlID == 44 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cCentralControlRoom.cPauseButton1.bOpreation_Button;
                }
                #endregion
                else
                { 
                    bMapStatus = false;
                }
            }
            else
            {
                #region 东中转池关映射
                if (byControlID == 4 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cSouthWater.bClose_Machine;
                }
                else if (byControlID == 4 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cEastTransitPool.cNorthWater.bClose_Machine;
                }
                #endregion 
                #region 西中转池开映射
                else if (byControlID == 49 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cWestTransitPool.cSouthWater.bClose_Machine;
                }
                else if (byControlID == 49 && strOperationChannelName[0] == "d2")
                {
                    bDelege_Operation = AllPond.cWestTransitPool.cNorthWater.bClose_Machine;
                }
                #endregion
                #region 中控柜关映射和手动映射
                else if (byControlID == 47 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cCentralControlRoom.cStopButton1.bOpreation_Button;
                }
                else if (byControlID == 44 && strOperationChannelName[0] == "d0")
                {
                    bDelege_Operation = AllPond.cCentralControlRoom.cHandButton1.bOpreation_Button;
                }                
                #endregion
                else
                {
                    bMapStatus = false;
                }
            }
            return bMapStatus;
        }
   }
#endif
}
